Allow a bigger range for the gantt timeline

2013-08-09 10:29 - Michael Heinze

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Gantt Estimated time: 0.00 hour

Target version: 4.1.0   

Resolution: Fixed   

Description

Currently the gantt chart can only display up to 24 months. Every bigger value is ignored and sets the chart back to 6 months.

There is no obvious reason for this constraint, so the possible range should be extended to more than 24 months (maybe 48 or a

configurable value).

Related issues:

Related to Redmine - Feature #9296: User preference for storing offset of mon... New 2011-09-21

Has duplicate Redmine - Feature #24550: Open GANTT for more than 24months Closed

Associated revisions

Revision 18136 - 2019-05-08 10:57 - Go MAEDA

Allow a bigger range for the gantt timeline (#14654).

Patch by Yuichi HARADA.

Revision 18137 - 2019-05-08 11:00 - Go MAEDA

Test for r18136 (#14654).

Patch by Go MAEDA.

Revision 18138 - 2019-05-08 11:01 - Go MAEDA

Update locales (#14654).

History

#1 - 2013-08-09 17:20 - Daniel Felix

The limitation is set in this file and line: source:trunk/lib/redmine/helpers/gantt.rb#L65

You can set this value (the second one in the if) to a higher value, for example 49 to define 4 years on a gantt.

Maybe this could be set per option, but this would be a workaround for you to get started.

#2 - 2014-11-05 12:12 - Liangfu Chen

Daniel Felix wrote:

The limitation is set in this file and line: source:trunk/lib/redmine/helpers/gantt.rb#L65

You can set this value (the second one in the if) to a higher value, for example 49 to define 4 years on a gantt.

Maybe this could be set per option, but this would be a workaround for you to get started.

 after i modified the line and restarted apache2, it still wouldn't work at all.

i thought there is some problem with the cache, but i've cleared it. left the problem unsolved.

#3 - 2014-12-04 13:43 - Toshi MARUYAMA

- Related to Feature #9296: User preference for storing offset of month in Gantt added

#4 - 2017-05-16 14:18 - nico cruz
Hi

has this issue still not been solved?

it is important to allow the view of more years in the Gantt diagram

nico

#5 - 2017-11-29 04:50 - Go MAEDA

- Has duplicate Feature #24550: Open GANTT for more than 24months added

#6 - 2019-04-26 04:53 - Yuichi HARADA

- File settings_gantt_months_limit.png added

- File gantt.png added

- File 14654.patch added

Added "Maximum number of months displayed on the gantt chart" to [Settings] > [Issue tracking].

 settings_gantt_months_limit.png 

Make this value the maximum number of months for the Gantt chart.

 gantt.png 

I attached a patch.

#7 - 2019-04-26 08:18 - Go MAEDA

- File test-for-14654.patch added

- Target version set to Candidate for next major release

Here is a test for the patch attached in #14654#note-6.

#8 - 2019-04-26 08:22 - Go MAEDA

- Status changed from New to Needs feedback

Thank you for the patch.

We should consider the behavior when Setting.gantt_months_limit is less than 6.

Assume that Setting.gantt_months_limit is 0. You will see a chart with 6 months long. But you cannot enter the value between 1 and 6 to

input#months. In other words, you see 6 months chart but you cannot make the gantt shorter, for example, 5 months. I think the behavior is strange.

Maybe it is better to have a lower limit of Setting.gantt_months_limit. In my opinion,  gantt should behave as if Setting.gantt_months_limit is 6 when

Setting.gantt_months_limit is less than 6.

I think the lower limit should be 6.

#9 - 2019-05-07 07:55 - Yuichi HARADA

- File 14654_v2.patch added

Go MAEDA wrote:

Maybe it is better to have a lower limit of Setting.gantt_months_limit. In my opinion,  gantt should behave as if Setting.gantt_months_limit is 6

when Setting.gantt_months_limit is less than 6.

I think the lower limit should be 6.

 Thank you for pointing out.

If Setting.gantt_months_limit is less than 6, gantt has rebuilt the patch to behave as if Setting.gantt_months_limit is 6.

#10 - 2019-05-07 11:50 - Go MAEDA

- Status changed from Needs feedback to New

- Target version changed from Candidate for next major release to 4.1.0

Setting the target version to 4.1.0.

2024-03-13 2/3

https://www.redmine.org/issues/14654#note-6


#11 - 2019-05-07 18:23 - Marius BĂLTEANU

We should move [6, Setting.gantt_months_limit.to_i].max to a method in order to avoid duplicating the logic in two places (view and lib).

#12 - 2019-05-08 03:42 - Go MAEDA

- Assignee set to Marius BĂLTEANU

Marius BALTEANU wrote:

We should move [6, Setting.gantt_months_limit.to_i].max to a method in order to avoid duplicating the logic in two places (view and lib).

 I think it is a bit overkill to add a method somewhere. Since the problem I pointed out in #14654#note-8 is really small, I think it is OK to apply the first

patch (14654.patch). Marius, what do you think about this approach?

#13 - 2019-05-08 06:59 - Marius BĂLTEANU

Go MAEDA wrote:

Marius BALTEANU wrote:

We should move [6, Setting.gantt_months_limit.to_i].max to a method in order to avoid duplicating the logic in two places (view and lib).

 I think it is a bit overkill to add a method somewhere. Since the problem I pointed out in #14654#note-8 is really small, I think it is OK to apply the

first patch (14654.patch). Marius, what do you think about this approach?

 No problem for me.

#14 - 2019-05-08 11:01 - Go MAEDA

- Status changed from New to Closed

- Assignee changed from Marius BĂLTEANU to Go MAEDA

- Resolution set to Fixed

Committed the patches.

Files

settings_gantt_months_limit.png 105 KB 2019-04-26 Yuichi HARADA

gantt.png 61.6 KB 2019-04-26 Yuichi HARADA

14654.patch 2.95 KB 2019-04-26 Yuichi HARADA

test-for-14654.patch 1.12 KB 2019-04-26 Go MAEDA

14654_v2.patch 2.97 KB 2019-05-07 Yuichi HARADA
